//	bfe2 - memory dump
//	Copyright (c) 1999-2003 Brand Huntsman and Lee Salzman
//


#include "common.h"
#include "functions.h"


//////////////////////////////////////////////////////////////////////////

// global
s_memwin *mem_windows;
char mem_type, mem_size, mem_physical;

// local
GtkWidget *mem_address_text, *mem_size_text, *mem_dump_button;

//////////////////////////////////////////////////////////////////////////


/*
void show_memory( FL_OBJECT *obj, long argument ){
	s_memwin *tmp;
	char temp[100];

	if((tmp = (s_memwin *)malloc(sizeof(s_memwin))) == NULL) return;

	if(mem_windows == NULL){
		mem_windows = tmp;
		tmp->next = NULL;
	} else {
		tmp->next = mem_windows;
		mem_windows->prev = tmp;
		mem_windows = tmp;
	}
	tmp->prev = NULL;
	tmp->physical = mem_physical;
	tmp->unit_format = mem_type;
	tmp->unit_size = mem_size;
	tmp->units = atoi(fl_get_input(m_size_text));
	tmp->address = strtol(fl_get_input(m_address_text), NULL, 16);
	fl_set_input(m_address_text, NULL);
	fl_set_input(m_size_text, NULL);

	tmp->window = fl_bgn_form(FL_FLAT_BOX, 550, 300);

	tmp->list = fl_add_browser(FL_HOLD_BROWSER,            5,   5, 540, 265, NULL);
	fl_set_object_lstyle(tmp->list, FL_FIXED_STYLE);
	fl_set_object_gravity(tmp->list, FL_NorthWest, FL_SouthEast);
	fl_set_object_resize(tmp->list, FL_RESIZE_ALL);

	tmp->refresh_button = fl_add_button(FL_NORMAL_BUTTON,   440, 270,  50,  25, "Refresh");
	fl_set_object_lstyle(tmp->refresh_button, FL_BOLD_STYLE);
	fl_set_object_callback(tmp->refresh_button, refresh_memory, (long)tmp);
	fl_set_object_gravity(tmp->refresh_button, FL_SouthEast, FL_SouthEast);
	fl_set_object_resize(tmp->refresh_button, FL_RESIZE_NONE);

	tmp->close_button = fl_add_button(FL_NORMAL_BUTTON,   495, 270,  50,  25, "Close");
	fl_set_object_lstyle(tmp->close_button, FL_BOLD_STYLE);
	fl_set_object_callback(tmp->close_button, close_memory, (long)tmp);
	fl_set_object_gravity(tmp->close_button, FL_SouthEast, FL_SouthEast);
	fl_set_object_resize(tmp->close_button, FL_RESIZE_NONE);

	fl_end_form();

	if(mem_physical == 1){
		snprintf(temp, 100, "BFE - Memory Dump - 0x%.8X physical", tmp->address);
	}else{
		snprintf(temp, 100, "BFE - Memory Dump - 0x%.8X linear", tmp->address);
	}
	fl_show_form(tmp->window, FL_PLACE_MOUSE|FL_FREE_SIZE, FL_FULLBORDER, temp);
	update_memory((long)tmp);
}


void close_memory( FL_OBJECT *obj, long argument ){
	s_memwin *tmp;

	tmp = (s_memwin *)argument;
	fl_hide_form(tmp->window);

	if(tmp->prev == NULL){
		if(tmp->next != NULL){
			mem_windows = tmp->next;
			mem_windows->prev = NULL;
		} else mem_windows = NULL;
	} else {
		tmp->prev->next = tmp->next;
	}

	free(tmp);
}
        
        
void refresh_memory( FL_OBJECT *obj, long argument ){
	if(bochs_running){
		fl_ringbell(0);
		return;
	}
	update_memory(argument);
}


void set_memory_physical( FL_OBJECT *obj, long argument ){
	mem_physical = (uint32)argument;
}


void set_memory_type( FL_OBJECT *obj, long argument ){
	if(obj==m_type_hex) mem_type = 'x';
	if(obj==m_type_dec) mem_type = 'd';
	if(obj==m_type_uns) mem_type = 'u';
	if(obj==m_type_oct) mem_type = 'o';
	if(obj==m_type_bin) mem_type = 't';
}


void set_memory_size( FL_OBJECT *obj, long argument ){
	if(obj==m_size_byte)  mem_size = 'b';
	if(obj==m_size_word)  mem_size = 'h';
	if(obj==m_size_dword) mem_size = 'w';
	if(obj==m_size_qword) mem_size = 'g';
}
*/


//////////////////////////////////////////////////////////////////////////


void memoryInit( GtkWidget *vbox ){
}


void memoryUpdate( ){
}


void memoryUpdateWindow( long tmp ){
/*
	s_memwin *m;
	char string[200], c, *s;

	if(bochs_offline) return;

	string[0]='@'; string[1]='b';
	s = &string[2];
	m = (s_memwin *)tmp;

	fl_freeze_form(m->window);
	fl_clear_browser(m->list);

	if(m->physical == 1){
	  fprintf(writepipe, "xp /%d%c%c 0x%X\n", m->units, m->unit_size, m->unit_format, m->address);
	}else{
	  fprintf(writepipe, "x /%d%c%c 0x%X\n", m->units, m->unit_size, m->unit_format, m->address);
	}

	fgetc(readpipe);

	for(;;){
		c=fgetc(readpipe);
		if(c == '\n'){
			*s = '\0';
			fl_add_browser_line(m->list, string);
			s = &string[2];
		} else if(c == '<'){
			if(s == &string[2]){
				fscanf(readpipe, "bochs:%u>", &p_step);
				break;
			} else {
				fscanf(readpipe, "bogus");
			}
		} else if(c == '>'){
			fgetc(readpipe);
		} else if(c == EOF){
			break;
		} else if(c == ' ' || c == '\t'){
			if(s[-1] != '\t'){ *s = '\t'; s++; }
		} else {
			*s = c; s++;
		}
	}
	fl_unfreeze_form(m->window);
*/
}


void memoryEnablePage( gboolean v ){
	gtk_widget_set_sensitive(mem_address_text, v);
	gtk_widget_set_sensitive(mem_size_text, v);
	gtk_widget_set_sensitive(mem_dump_button, v);
}
